var _class, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @memberof components
 * @namespace Drawer
 * @author Steven Jackson
* @scss ../../scss/components/Drawer
 * @example <Drawer>
             Example Content
           </Drawer>
 */
import React from "react";
import _ from "lodash";
import classNames from "classnames";
import { CoreComponent, setCorePropDefaults, getValidProps, UIGlobals, ROLE } from "../../lib";
import Content from "../Content/Content.js";
import "./Drawer.css";

var Drawer = (_temp = _class = function (_CoreComponent) {
  _inherits(Drawer, _CoreComponent);

  function Drawer() {
    _classCallCheck(this, Drawer);

    return _possibleConstructorReturn(this, _CoreComponent.apply(this, arguments));
  }

  Drawer.prototype.render = function render() {
    var _this2 = this;

    var _getValidProps = getValidProps(this.props),
        Component = _getValidProps.renderAs,
        uiclass = _getValidProps.uiclass,
        color = _getValidProps.color,
        colorStyle = _getValidProps.colorStyle,
        uuid = _getValidProps.uuid,
        fixed = _getValidProps.fixed,
        disabled = _getValidProps.disabled,
        collapsed = _getValidProps.collapsed,
        children = _getValidProps.children,
        props = _getValidProps.props;

    return React.createElement(
      Component,
      props,
      React.createElement(
        Content,
        null,
        React.Children.map(children, function (child) {
          return _this2.renderChild(child, {
            disabled: disabled,
            uiclass: uiclass,
            collapsed: collapsed
          });
        })
      )
    );
  };

  return Drawer;
}(CoreComponent), _class.defaultProps = setCorePropDefaults({
  uirole: ROLE.DRAWER,
  collapsed: true
}), _temp);


export default Drawer;