var _class, _temp2;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @memberof components
 * @namespace Grid
 * @author Steven Jackson
* @scss ../../scss/components/Grid
 * @example <Grid>
             Example Content
           </Grid>
 */
import React from "react";
import { CoreComponent, getValidProps, setCorePropDefaults, ROLE } from "../../lib";
import GridRow from "./GridRow.js";
import GridColumn from "./GridColumn.js";
import "./Grid.css";

var Grid = (_temp2 = _class = function (_CoreComponent) {
  _inherits(Grid, _CoreComponent);

  function Grid() {
    var _temp, _this, _ret;

    _classCallCheck(this, Grid);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _CoreComponent.call.apply(_CoreComponent, [this].concat(args))), _this), _this.renderCore = function () {
      var _getValidProps = getValidProps(_this.props),
          Component = _getValidProps.renderAs,
          children = _getValidProps.children,
          props = _getValidProps.props,
          inherited = _getValidProps.inherited;

      return React.createElement(
        Component,
        props,
        React.Children.map(children, function (child) {
          if (typeof child.props !== "undefined" && typeof child.props.uirole !== "undefined") {
            switch (child.props.uirole) {
              case ROLE.ROW:
                return _this.renderChild(child, inherited);
              default:
                return child;
            }
          }
          return child;
        })
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return Grid;
}(CoreComponent), _class.defaultProps = setCorePropDefaults({
  renderAs: "div",
  uirole: ROLE.GRID
}), _class.Row = GridRow, _class.Column = GridColumn, _temp2);


export default Grid;