var _class, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @memberof components
 * @namespace Loading
 * @author Steven Jackson
 * @scss ../../scss/components/Loading
 * @example <Loading>
             Example Content
           </Loading>
 */
import React from "react";
import { CoreComponent, setCorePropTypes, setCorePropDefaults, getValidProps, ROLE } from "../../lib";
import "./Loading.css";

var Loading = (_temp = _class = function (_CoreComponent) {
  _inherits(Loading, _CoreComponent);

  function Loading() {
    _classCallCheck(this, Loading);

    return _possibleConstructorReturn(this, _CoreComponent.apply(this, arguments));
  }

  Loading.prototype.render = function render() {
    var _getValidProps = getValidProps(this.props),
        scene = _getValidProps.scene,
        children = _getValidProps.children,
        props = _getValidProps.props;

    var wrapperClass = "ui-loading-" + scene;
    var actorClass = "ui-loading-" + scene + "-actor";
    var leftClass = "ui-loading-" + scene + "-left";
    var rightClass = "ui-loading-" + scene + "-right";
    var centerClass = "ui-loading-" + scene + "-center";
    return React.createElement(
      "div",
      props,
      React.createElement(
        "div",
        { className: "ui-loading-scene-wrapper " + wrapperClass },
        React.createElement(
          "div",
          { className: "ui-loading-scene" },
          React.createElement("div", { className: actorClass + " " + leftClass }),
          React.createElement(
            "div",
            { className: actorClass + " " + centerClass },
            React.createElement("div", { className: centerClass + "1" }),
            React.createElement("div", { className: centerClass + "2" }),
            React.createElement("div", { className: centerClass + "3" }),
            React.createElement("div", { className: centerClass + "4" }),
            React.createElement("div", { className: centerClass + "5" }),
            React.createElement("div", { className: centerClass + "6" }),
            React.createElement("div", { className: centerClass + "7" }),
            React.createElement("div", { className: centerClass + "8" }),
            React.createElement("div", { className: centerClass + "9" })
          ),
          React.createElement("div", { className: actorClass + " " + rightClass })
        )
      )
    );
  };

  return Loading;
}(CoreComponent), _class.propTypes = setCorePropTypes({
  scene: "string"
}), _class.defaultProps = setCorePropDefaults({
  renderAs: "div",
  uirole: ROLE.LOADING,
  scene: "sheep"
}), _temp);


export default Loading;