var _class, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @memberof components
 * @namespace ToolTip
 * @author Steven Jackson
 * @scss ../../scss/components/ToolTip
 * @example <div>
   <ToolTip position="right">Example Tooltip</ToolTip>
 </div>
 */
import React from "react";
import { CoreComponent, setCorePropDefaults, getValidProps, ROLE } from "../../lib";
import "./ToolTip.css";

var ToolTip = (_temp = _class = function (_CoreComponent) {
  _inherits(ToolTip, _CoreComponent);

  function ToolTip() {
    _classCallCheck(this, ToolTip);

    return _possibleConstructorReturn(this, _CoreComponent.apply(this, arguments));
  }

  ToolTip.prototype.render = function render() {
    var _getValidProps = getValidProps(this.props),
        Component = _getValidProps.renderAs,
        text = _getValidProps.text,
        position = _getValidProps.position,
        children = _getValidProps.children,
        props = _getValidProps.props;

    var tipText = text || escape(children);
    return React.createElement(
      Component,
      { "data-ui-tooltip": tipText, "data-ui-tooltip-pos": position },
      children
    );
  };

  return ToolTip;
}(CoreComponent), _class.defaultProps = setCorePropDefaults({
  renderAs: "span",
  uirole: ROLE.TOOLTIP,
  position: "top"
}), _temp);


export default ToolTip;